#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/treeview.h>
#include <gtkmm/treestore.h>

#include "eggtreemultidnd.h"

class MyColumns : public Gtk::TreeModelColumnRecord
{
public:
  MyColumns()
  {
    add(m_col_name);
  }

  Gtk::TreeModelColumn<Glib::ustring> m_col_name;
};

void setup_treeview(Gtk::TreeView& tv)
{
  MyColumns columns;
  Glib::RefPtr<Gtk::TreeStore> refStore = Gtk::TreeStore::create(columns);
  tv.set_model(refStore);

  tv.set_reorderable();
  tv.set_rules_hint();
  tv.set_enable_search(false);

  Glib::RefPtr<Gtk::TreeSelection> selection = tv.get_selection();
  selection->set_mode(Gtk::SELECTION_MULTIPLE);

  Gtk::TreeRow row = *(refStore->append());
  row[columns.m_col_name] = "Blah";

  row = *(refStore->append());
  row[columns.m_col_name] = "Foo";

  tv.append_column("Name", columns.m_col_name);

  tv.show_all_children();
}

int main(int argc,
         char **argv)
{
  Gtk::Main main_instance(argc, argv);

  Gtk::TreeView tv;
  egg_tree_multi_drag_add_drag_support(tv.gobj());
  setup_treeview(tv);

  Gtk::Window win;
  win.add(tv);
  win.show_all();

  Gtk::Main::run(win);
  return 0;
}
